const express = require("express");
const bp = require('body-parser');
const db = require('./db.js');
const urlp = bp.urlencoded({ extended: true });
const app = express();

app.get("/status", async (req, res) => {
  res.json({ kode: "01", pesan: "API ExpressJS OK" });
});

app.get("/lokasidana", async (req, res) => {
    const dt = await db.getLokasiDana();
    console.log(dt);
    
    if(dt == false) {
      res.send('{"kode":"0","pesan":"Data Lokasi Dana Tidak Di Temukan"}');
    }else{
      res.send(`{"kode":"1","pesan":"Data Lokasi Dana Di Temukan","data":${JSON.stringify(dt)}}`);
    }
})

app.post("/penjualan", urlp, async (req, res) => {
    let tgl1 = req.body.tgl_awal;
    let tgl2 = req.body.tgl_akhir;
    const dt = await db.getPenjualan(tgl1, tgl2);
    if (dt == false) {
      res.send('{"kode":"0","pesan":"Data Penjualan Tidak Ditemukan"}');
    }else{
      let dtakhir = [];
      let jmldt = 0;
      for (x of dt) {
      jmldt++;
      let dtsub = [];
      let jenisbarang = 0;
      let jumlahbarang = 0;
      let total = 0;
      const dp = await db.getDetailPenjualan(x.id);
      for (y of dp){
          jenisbarang++;
          jumlahbarang += y.jumlah;
          total += (y.harga * y.jumlah);
          dtsub.push({
            "barang": y.nama,
            "harga_satuan": y.harga,
            "jumlah": y.jumlah,
            "satuan": y.satuan,
          });
      }
      dtakhir.push({
        "id_transaksi": x.id,
        "kepada": x.kepada,
        "alamat": x.alamat,
        "tgl_penjualan": x.tgl_jual,
        "jenis_barang": jenisbarang,
        "jumlah_barang": jumlahbarang,
        "total_harga": total,
        "detail": dtsub,
      });
    }
    res.send(`{
      "kode":"1",
      "pesan":"Data Penjualan Ditemukan",
      "jumlah_data":${jmldt},
      "data":${JSON.stringify(dtakhir)
    }}`);
  }
})

app.listen(3478, () => {
  console.log("API Berjalan di Port: 3478");
});